## ros-crystal-object-analytics-node 0.5.3

=== CMakeLists.txt ===
# Copyright (c) 2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)
project(object_analytics_node)

set(CRYSTAL_BLOOM_RELEASE TRUE)
# TODO(yechun1): always build tracking when opencv3.3 is available for debian package.
# Tracking feature depends on opencv3.3 libraries, the ubuntu 18.04 only support opencv3.2.
# to bloom release object package, we need to fix dependence issue, as there is no opencv3.3 debian packages,
# temporary removed tracking feature for bloom release object analytics as debian package.
if(NOT ${CRYSTAL_BLOOM_RELEASE})
    set(BUILD_TRACKING TRUE)
else()
    set(BUILD_TRACKING FALSE)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "set build type to Release" FORCE)
  message(${CMAKE_BUILD_TYPE})
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # we dont use add_compile_options with pedantic in message packages
  # because the Python C extensions dont comply with it
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)
find_package(class_loader REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(std_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(object_msgs REQUIRED)
find_package(object_analytics_msgs REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(message_filters REQUIRED)
find_package(pcl_conversions REQUIRED)
find_package(PCL 1.7 REQUIRED COMPONENTS
  common
  segmentation
  kdtree
  search
  filters
)

include_directories(
  include
  ${object_analytics_msgs_INCLUDE_DIRS}
  ${message_filters_INCLUDE_DIRS}
  ${pcl_conversions_INCLUDE_DIRS}
  ${PCL_COMMON_INCLUDE_DIRS}
  ${PCL_SEGMENTATION_INCLUDE_DIRS}
)

# create ament index resource which references the libraries in the binary dir
set(node_plugins "")

add_library(object_analytics_common SHARED
  src/const.cpp
  src/util/file_parser.cpp
  src/model/object2d.cpp
  src/model/object3d.cpp
  src/model/object_utils.cpp
)
target_compile_definitions(object_analytics_common
  PRIVATE "OBJECT_ANALYTICS_NODE_BUILDING_DLL"
)
ament_target_dependencies(object_analytics_common
  "sensor_msgs"
  "geometry_msgs"
  "object_msgs"
  "object_analytics_msgs"
  "pcl_conversions"
  "cv_bridge"
  "class_loader"
)
if(${BUILD_TRACKING})
  target_link_libraries(object_analytics_common
    ${PCL_COMMON_LIBRARIES}
    ${OpenCV_LIBRARIES}
  )
else()
  target_link_libraries(object_analytics_common
    ${PCL_COMMON_LIBRARIES}
  )
endif()

add_executable(object_analytics_node src/composition.cpp)
target_link_libraries(object_analytics_node ament_index_cpp::ament_index_cpp)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_link_libraries(object_analytics_node "stdc++fs")
endif()
ament_target_dependencies(object_analytics_node
  "class_loader"
  "rclcpp"
  "rcutils"
)
target_link_libraries(object_analytics_node object_analytics_common)

if(${BUILD_TRACKING})
  find_package(OpenCV 3.2 REQUIRED)
  add_executable(tracker_regression src/tracker/tracking_regression.cpp
    src/dataset/tr_dataset.cpp
    src/dataset/trimg_dataset.cpp
    src/dataset/trvid_dataset.cpp)
  target_link_libraries(tracker_regression ament_index_cpp::ament_index_cpp)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_link_libraries(tracker_regression "stdc++fs")
  endif()
  ament_target_dependencies(tracker_regression
    "object_analytics_msgs"
    "cv_bridge"
    "OpenCV"
    "object_msgs"
    "class_loader"
    "rclcpp"
    "rcutils"
  )
  target_link_libraries(tracker_regression object_analytics_common tracking_component)

  add_library(tracking_component SHARED
    src/tracker/tracking_node.cpp
    src/tracker/tracking.cpp
    src/tracker/tracking_manager.cpp
  )
  target_compile_definitions(tracking_component
    PRIVATE "OBJECT_ANALYTICS_NODE_BUILDING_DLL"
  )
  ament_target_dependencies(tracking_component
    "class_loader"
    "rclcpp"
    "sensor_msgs"
    "cv_bridge"
    "OpenCV"
    "object_msgs"
    "object_analytics_msgs"
  )
  target_link_libraries(tracking_component object_analytics_common)
  rclcpp_register_node_plugins(tracking_component "object_analytics_node::tracker::TrackingNode")
  set(node_plugins
    "${node_plugins}object_analytics_node::tracker::TrackingNode;$<TARGET_FILE:tracking_component>\n")
endif()

add_library(splitter_component SHARED
  src/splitter/splitter_node.cpp
  src/splitter/splitter.cpp
)
target_compile_definitions(splitter_component
  PRIVATE "OBJECT_ANALYTICS_NODE_BUILDING_DLL"
)
ament_target_dependencies(splitter_component
  "class_loader"
  "rclcpp"
  "sensor_msgs"
  "pcl_conversions"
)
target_link_libraries(splitter_component object_analytics_common)
rclcpp_register_node_plugins(splitter_component "object_analytics_node::splitter::SplitterNode")
set(node_plugins
  "${node_plugins}object_analytics_node::splitter::SplitterNode;$<TARGET_FILE:splitter_component>\n")

add_library(moving_component SHARED
  src/movement/moving_object_node.cpp
  src/movement/moving_objects.cpp
  src/movement/object_frame.cpp
  src/movement/param.cpp)

target_compile_definitions(moving_component
  PRIVATE "OBJECT_ANALYTICS_NODE_BUILDING_DLL"
)
ament_target_dependencies(moving_component
  "rclcpp"
  "object_analytics_msgs"
  "rmw_implementation"
  "std_msgs"
  "sensor_msgs"
  "geometry_msgs"
  "object_msgs"
  "message_filters"
  "ament_index_cpp"
  "class_loader"
)
target_link_libraries(moving_component object_analytics_common)
rclcpp_register_node_plugins(moving_component "object_analytics_node::movement::MovementNode")
set(node_plugins
  "${node_plugins}object_analytics_node::movement::MovementNode;$<TARGET_FILE:moving_component>\n")

add_library(segmenter_component SHARED
  src/segmenter/segmenter_node.cpp
  src/segmenter/segmenter.cpp
  src/segmenter/algorithm_provider_impl.cpp
  src/segmenter/organized_multi_plane_segmenter.cpp
)
target_compile_definitions(segmenter_component
  PRIVATE "OBJECT_ANALYTICS_NODE_BUILDING_DLL"
)
ament_target_dependencies(segmenter_component
  "class_loader"
  "rclcpp"
  "sensor_msgs"
  "object_msgs"
  "object_analytics_msgs"
  "message_filters"
)
target_link_libraries(segmenter_component object_analytics_common ${PCL_SEGMENTATION_LIBRARIES})
rclcpp_register_node_plugins(segmenter_component "object_analytics_node::segmenter::SegmenterNode")
set(node_plugins
  "${node_plugins}object_analytics_node::segmenter::SegmenterNode;$<TARGET_FILE:segmenter_component>\n")


install(TARGETS
  splitter_component
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(TARGETS
  object_analytics_node
  DESTINATION lib/${PROJECT_NAME}
)


if(${BUILD_TRACKING})
  install(TARGETS
    object_analytics_common
    segmenter_component
    tracking_component
    moving_component
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION lib
  )

  install(TARGETS
    tracker_regression
    DESTINATION lib/${PROJECT_NAME}
  )
else()
  install(TARGETS
    object_analytics_common
    segmenter_component
    moving_component
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION lib
  )
endif()

# Flags
if(UNIX OR APPLE)
  # Linker flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # GCC specific flags. ICC is compatible with them.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z noexecstack -z relro -z now")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # In Clang, -z flags are not compatible, they need to be passed to linker via -Wl.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} \
      -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} \
      -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
  endif()

  # Compiler flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    # GCC specific flags.
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9 OR
        CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.9)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector-strong")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
    endif()
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # Clang is compatbile with some of the flags.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # Same as above, with exception that ICC compilation crashes with -fPIE option, even
    # though it uses -pie linker option that require -fPIE during compilation. Checksec
    # shows that it generates correct PIE anyway if only -pie is provided.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector")
  endif()

  # Generic flags.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -fno-operator-names -Wformat -Wformat-security \
    -Wall -fopenmp")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  # Dot not forward c++11 flag to GPU beucause it is not supported
  set( CUDA_PROPAGATE_HOST_FLAGS OFF )
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D_FORTIFY_SOURCE=2")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(tests)
endif()

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}/
)

ament_package()

=== tests/CMakeLists.txt ===
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_lint_auto REQUIRED)
find_package(object_msgs REQUIRED)
find_package(object_analytics_msgs REQUIRED)

ament_lint_auto_find_test_dependencies()

find_package(PCL 1.7 REQUIRED COMPONENTS
  io
)
if(${BUILD_TRACKING})
  set(UNITEST_LIBRARIES
    pthread
    ${GTEST_LIBRARIES}
    ${PCL_IO_LIBRARIES}
    segmenter_component
    splitter_component
    tracking_component
  )
else()
  set(UNITEST_LIBRARIES
    pthread
    ${GTEST_LIBRARIES}
    ${PCL_IO_LIBRARIES}
    segmenter_component
    splitter_component
  )
endif()

get_filename_component(RESOURCE_DIR "resource" ABSOLUTE)
configure_file(unittest_util.hpp.in unittest_util.hpp)
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${object_msgs_INCLUDE_DIRS})

ament_add_gtest(unittest_object2d unittest_object2d.cpp unittest_util.cpp
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
if(TARGET unittest_object2d)
  target_link_libraries(unittest_object2d ${UNITEST_LIBRARIES})
endif()

ament_add_gtest(unittest_object3d unittest_object3d.cpp unittest_util.cpp
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
if(TARGET unittest_object3d)
  target_link_libraries(unittest_object3d ${UNITEST_LIBRARIES})
endif()

ament_add_gtest(unittest_objectutils unittest_objectutils.cpp unittest_util.cpp
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
if(TARGET unittest_objectutils)
  target_link_libraries(unittest_objectutils ${UNITEST_LIBRARIES})
endif()

ament_add_gtest(unittest_segmenter unittest_segmenter.cpp unittest_util.cpp
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
if(TARGET unittest_segmenter)
  target_link_libraries(unittest_segmenter ${UNITEST_LIBRARIES})
endif()

ament_add_gtest(unittest_splitter unittest_splitter.cpp unittest_util.cpp
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
if(TARGET unittest_splitter)
  target_link_libraries(unittest_splitter ${UNITEST_LIBRARIES})
endif()

if(${BUILD_TRACKING})
  ament_add_gtest(unittest_tracking unittest_tracking.cpp
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
  if(TARGET unittest_tracking)
    target_link_libraries(unittest_tracking ${UNITEST_LIBRARIES})
  endif()

  ament_add_gtest(unittest_trackingmanager unittest_trackingmanager.cpp unittest_util.cpp
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
  if(TARGET unittest_trackingmanager)
    target_link_libraries(unittest_trackingmanager ${UNITEST_LIBRARIES})
  endif()
endif()

=== debian/changelog ===
ros-crystal-object-analytics-node (0.5.3-0bionic) bionic; urgency=high

  * Merge remote-tracking branch 'upstream/devel'
  * delete no tracking launch file
    this file is no used.
  * Merge pull request #66 from intel/unit_test
    fix unittest segment issue
  * fix unittest_segmenter failure
  * Merge pull request #65 from intel/obj_id_zero
    Obj id zero
  * fix build warning with unused parameter
    fix warning: unused parameter ‘cloud’ [-Wunused-parameter]
  * Merge pull request #56 from intel/gtest
    add ament_cmake_gtest in package.xml
  * add ament_cmake_gtest in package.xml
  * Contributors: Chris Ye

 -- Chris Ye <chris.ye@intel.com>  Wed, 23 Jan 2019 16:00:00 -0000

ros-crystal-object-analytics-node (0.5.2-0bionic) bionic; urgency=high

  * rename launcher filename
  * add ament_cmake_gtest in package.xml
  * Merge remote-tracking branch 'origin/master' into crystal
  * Disable tracking for CRYSTAL RELEASE
  * Contributors: Chris Ye

 -- Chris Ye <chris.ye@intel.com>  Thu, 06 Dec 2018 16:00:00 -0000

ros-crystal-object-analytics-node (0.5.1-0bionic) bionic; urgency=high

  * Merge pull request #55 <https://github.com/intel/ros2_object_analytics/issues/55> from intel/devel
    update launcher file and license
  * update launcher file and license
  * Merge pull request #54 <https://github.com/intel/ros2_object_analytics/issues/54> from nuclearsandwich/dependencies
    Reconcile dependencies between package.xml and CMakeLists.txt
  * Merge pull request #53 <https://github.com/intel/ros2_object_analytics/issues/53> from intel/devel
    remove depth_image_proc when launch
  * Add ament_index dependencies to the package manifest.
    Failures due to these missing dependencies were encountered on the ROS
    buildfarm. I added ament_index_python as an exec depend as it appears to
    be used by the launch files included with the package.
  * remove depth_image_proc when launch
    depth_image_proc will has reduce image transport performance, subscribe pointcloud from camera directly, although there has blue points. To fix later with good performance.
  * Merge pull request #52 <https://github.com/intel/ros2_object_analytics/issues/52> from intel/for_release
    For release
  * add BUILD_TRACKING option
    Add BUILD_TRACKING option in order to disable tracking build for crystal bloom release, as opencv3.3 no provided debian installation from ubuntu18.04
  * remap topic in launch instead of code hardcode
    remap topic name in launch.py instead of hardcode in code
  * Contributors: Chris Ye, Steven! Ragnarök

 -- Chris Ye <chris.ye@intel.com>  Wed, 05 Dec 2018 16:00:00 -0000

ros-crystal-object-analytics-node (0.5.0-0bionic) bionic; urgency=high

  * update launch file
    * delete object_analytics_launch package and create object_analytics_node/launch folder
    * rename node name from composition to object_anaytics_node
    * fix loading MovementNode to class typo
    * update readme to simple launch example
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Merge pull request #49 <https://github.com/yechun1/ros2_object_analytics/issues/49> from ahuizxc/merged_mo
    Enable moving object feature
  * changed code as recommended
  * merged with moving object project
  * Merge pull request #44 <https://github.com/yechun1/ros2_object_analytics/issues/44> from ahuizxc/master
    remove merger-node to simplify the code
  * remove merger-node to simplify the code
  * Merge pull request #43 <https://github.com/yechun1/ros2_object_analytics/issues/43> from intel/fix_build_issue
    add semicolon after RCLCPP_INFO
  * add semicolon after RCLCPP_INFO
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Merge pull request #42 <https://github.com/yechun1/ros2_object_analytics/issues/42> from challen-zhou/master
    Enable tracking algorithm select in tracker_regression tool
  * Merge pull request #41 <https://github.com/yechun1/ros2_object_analytics/issues/41> from qingmingjie/test
    modify unittest_trackingmanager.cpp based on tracking new code.
  * Enable tracking algorithm select in tracker_regression tool
    1. Enable tracker_regression tool to select algorithms for tracking.
    2. Add tracker_regression tool usage introduction.
  * modify unittest_trackingmanager.cpp
  * Merge pull request #40 <https://github.com/yechun1/ros2_object_analytics/issues/40> from intel/ament_test
    Ament test
  * update copyright format to pass colcon test
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * use ament_lint_auto for ros2 code style check
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Merge pull request #39 <https://github.com/yechun1/ros2_object_analytics/issues/39> from challen-zhou/master
    Enable tracking dataset support
  * Tuning tracker's roburst to detection
    1. Tuning tracker's strategy to be more roburst to detection's result.
    2. Change code style to match ROS2 requirement.
  * Enabled more tracking features
    1. Changed tracking tick tock to image data topic instead of detection topic.
    2. Enabled more tracking features such as KCF/TLD/BOOSTING/MEDIAN_FLOW.
  * Enable tracking dataset support
    1. Add functions to enable dataset support in tracking module.
    2. Add one regression tool to track tracking precision and perf.
  * Merge pull request #38 <https://github.com/yechun1/ros2_object_analytics/issues/38> from ahuizxc/remove_plane_seg
    remove the plane segment part according to the new algorithm
  * remove the plane segment part according to the new algorithm
  * Merge pull request #36 <https://github.com/yechun1/ros2_object_analytics/issues/36> from intel/message_filter
    update message_filter and interface
  * update message_filter and interface
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Contributors: Chris Ye, ahuizxc, challen.zhou, qingmingjie

 -- Chris Ye <chris.ye@intel.com>  Tue, 13 Nov 2018 16:00:00 -0000

ros-crystal-object-analytics-node (0.4.0-0bionic) bionic; urgency=high



=== debian/control ===
Source: ros-crystal-object-analytics-node
Section: misc
Priority: extra
Maintainer: Chris Ye <chris.ye@intel.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-dev, ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ament-index-cpp, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-geometry-msgs, ros-crystal-message-filters, ros-crystal-object-analytics-msgs, ros-crystal-object-msgs, ros-crystal-pcl-conversions, ros-crystal-rclcpp, ros-crystal-sensor-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-object-analytics-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-apps1.8, libpcl-common1.8, libpcl-dev, libpcl-features1.8, libpcl-filters1.8, libpcl-io1.8, libpcl-kdtree1.8, libpcl-keypoints1.8, libpcl-ml1.8, libpcl-octree1.8, libpcl-outofcore1.8, libpcl-people1.8, libpcl-recognition1.8, libpcl-registration1.8, libpcl-sample-consensus1.8, libpcl-search1.8, libpcl-segmentation1.8, libpcl-stereo1.8, libpcl-surface1.8, libpcl-tracking1.8, libpcl-visualization1.8, ros-crystal-ament-index-cpp, ros-crystal-ament-index-python, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-geometry-msgs, ros-crystal-message-filters, ros-crystal-object-analytics-msgs, ros-crystal-object-msgs, ros-crystal-pcl-conversions, ros-crystal-rclcpp, ros-crystal-sensor-msgs, ros-crystal-std-msgs, ros-crystal-ros-workspace
Description: The object_analytics_node package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-object-analytics-node//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
